#!ruby -Imswin32

require 'yarvutil'

puts YARVCore::VERSION + " rev: #{YARVCore::REV} (#{YARVCore::DATE})"
puts YARVCore::OPTS

$line = __LINE__ + 3
###########################################################
$prog =<<'__EOP__'

def foo
 3.timed do    return
 end
end

foo

__END__
def foo
  3.times{|i|
    return
  }
end

foo
__END__

p 'hello yasm'

def m1 a, b
  p [a, b]
end

m1 100, 200

__END__
def test(arg)
  case 1
  when 2
    3
  end
  return arg
end

test(100)

__END__
a = {1 => 10}
a[0] ||= 1


__EOP__
###########################################################

puts YARVUtil.parse($prog, $0, $line).disasm
exit if ARGV[0] == 'po'

$lpback = $".dup

puts '-----------------------------------------------------------------------------'
$ans = YARVUtil.eval($prog, $0, $line)
puts '-----------------------------------------------------------------------------'
puts "result: #{$ans.inspect}"

$".replace $lpback
puts "ruby  : #{YARVUtil.eval_in_wrap($prog, $0, $line).inspect}"

YARVUtil.dump_usage_analisys

